#Compiler_Res_Comment=Read aloud GOOGLE Headlines     ;Comment field

#Compiler_Res_Description=Read aloud GOOGLE Headlines     ;Description field

#Compiler_Res_Fileversion=1.0.0.0    ;File Version

#Compiler_Res_LegalCopyright=Lee Cole leecole@bigfoot.com  ;Copyright field
#Compiler_Res_Field=Email:|Lee Cole leecole@bigfoot.com Subject: AutoXvid
;; Acknowledgements: Dale "Internet Explorer Automation UDF library" and Valik for SEMAPHORE and Unknown "speaks text to you"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

#include <GUIConstants.au3>
#include <IE.au3>
#Include <Constants.au3>
#NoTrayIcon

Global $Max 
global $Voice 
Global $Type[10] ;"Tech","National","World","Medical","Sports","Entertainment"
Global $key
Global $showweb
Global $details
Global $Silent
Global $Speak
Global $oIE
Global $msg
Global $ui
Dim $HeadLines[99]
local $count = 0
local $ignore = 1
local $foundContact = 0
local $start = 0
local $end = 1
Func OnAutoItStart()
 SingleTon("Headlines_Reader")
EndFunc  ;==>OnAutoItStart

Func SingleTon($SEMAPHORE)	; Thank's Valik
  Local $ERROR_ALREADY_EXISTS = 183
  DllCall ("kernel32.dll", "int", "CreateSemaphore", "int", 0, "long", 1, "long", 1, "str", $SEMAPHORE)
  Local $LASTERROR = DllCall ("kernel32.dll", "int", "GetLastError")
  If $LASTERROR[0] = $ERROR_ALREADY_EXISTS Then Exit -1
EndFunc  ;==>Singleton

Opt("TrayMenuMode",1)   ; Default tray menu items (Script Paused/Exit) will not be shown.
$aboutitem  = TrayCreateItem("About")
$ui = TrayCreateItem("UnInstall")
TraySetState()
$cnt = 0
CheckInstall()	; Self install
GetParms($Type)
$oIE = _IECreate(0)
For $t=1 To $Type[0]
	ReDim $HeadLines[99]
	$cnt = 0
	$count = 0
	$key = Stringlower(Stringleft($Type[$t],1))
	$msg = TrayGetMsg()
	If $msg == $ui Then Uninstall()
	_IEAction($oIE, "invisible")
	_IENavigate($oIE, "http://news.google.ie/?ned=us&topic=" & $key) ;"http://www.rte.ie/news/")
	$o_all = _IETagNameAllGetCollection ($oIE)
	_IEGetHeadlines($o_all, $HeadLines)
	_IEAction($oIE, "selectall")
	_IEAction($oIE, "copy")
	_IEAction($oIE, "unselect")
	If $showweb=1 Then _IEAction($oIE, "visible")
	If $details Then
		$Text= ClipGet()
		FileWrite(@ScriptDir & "\News.txt",$Text)
		$file3 = FileOpen(@ScriptDir & "\News.txt",0)
		$count = 0
		$ignore = 1
		$foundContact = 0
		$start = 0
		$end = 1
	EndIf
	_TalkOBJ("Now the " & $Type[$t] & " News", $Voice)
	While 1
		$msg = TrayGetMsg()
		If $msg == $ui Then Uninstall()
		If $msg == $aboutitem Then
			MsgBox(0,"Headlines_Reader","Reads headlines from Google News",600)
			$msg = 0
			ContinueLoop
		EndIf
		
		If $details Then
			local $line = FileReadLine($file3)
			If @error = -1 Then ExitLoop
			If	$end And StringInStr($line,"-") then
				$start = 1
				$end = 0
			EndIf
		
			If StringInStr($line,"") Then
				$start = 0
				$end = 1
			EndIf
		
		
			If $count=$Max and $end Then ExitLoop
			If ($foundContact And $start) Then
				$count = $count +1
				$ignore = 0
				Sleep(1000)
				$cnt = $cnt + 1
				_TalkOBJ($Type[$t] & " Headline number " & $count & ", from," & $HeadLines[$cnt] , $Voice)
				$cnt = $cnt + 1
				Sleep(1000)
				_TalkOBJ($HeadLines[$cnt], $Voice)
				$start = 0
			EndIf
			$HeadLine = $line
			If $foundContact  Then
				if Not $ignore Then
					If Not $end Then
					;If $details Then 
						_TalkOBJ(StringLower($line), $Voice)
						$ignore = 0
					Else
						$ignore = 1
					EndIf
				EndIf
			EndIf
			If StringInStr($line,"Google News") Then 
				$foundContact = 1
				$end = 1
			EndIf
		
			If StringInStr($line,"International versions") Then  $foundContact = 0
		Else
			$count = $count + 1	
			$cnt = $cnt + 1
			_TalkOBJ($Type[$t] & " Headline number " & $count & ", from," & $HeadLines[$cnt] , $Voice)
			$cnt = $cnt + 1
			Sleep(1000)
			_TalkOBJ($HeadLines[$cnt], $Voice)	
			If $count = $Max Then ExitLoop
		EndIf
	WEnd
	If $details Then
		FileClose($file3)
		FileDelete(@ScriptDir & "\News.txt")
	EndIf
Next
$msg = TrayGetMsg()
If $msg == $ui Then Uninstall()
_TalkOBJ("That was the Headlines for Today", $Voice)
_TalkOBJ("This Program was Brought to you by Lee Cole", $Voice)
_TalkOBJ("Hope You Enjoyed It, Good Bye", $Voice)
_IEQuit($oIE)
Exit

Func _TalkOBJ($s_text, $s_voice = 3)
	$msg = TrayGetMsg()
	If $msg == $ui Then Uninstall()
	Local $o_speech = ObjCreate ("SAPI.SpVoice")
	Select
		Case $s_voice == 0
			Return
		Case $s_voice == 1
			$o_speech.Voice = $o_speech.GetVoices("Name=Microsoft Mary", "Language=409").Item(0)
			If $showweb=0 Then TrayTip("Female Reader",$s_text,1)
		Case $s_voice == 2
			$o_speech.Voice = $o_speech.GetVoices("Name=Microsoft Mike", "Language=409").Item(0)
			If $showweb=0 Then TrayTip("Male Reader",$s_text,1)
		Case $s_voice == 3
			$o_speech.Voice = $o_speech.GetVoices("Name=Microsoft Sam", "Language=409").Item(0)
			If $showweb=0 Then TrayTip("OldMan Reader",$s_text,1)
	EndSelect
	$o_speech.Speak ($s_text)
	$o_speech = ""
EndFunc   ;==>_TalkOBJ

Func GetParms(ByRef $_Type)
	Local $Ini = @ScriptDir & "\HeadLines.ini",$time[3]
	$Voice = Gender(IniRead($Ini,"NewsReader","Voice",1))
	$_Type = StringSplit(IniRead($Ini,"NewsReader","Subject","National"), ",")
	$Max = IniRead($Ini,"NewsReader","Number",100)
	$showweb = YesNo(IniRead($Ini,"NewsReader","ShowWeb",0))
	$details = YesNo(IniRead($Ini,"NewsReader","Details",0))
	$repeat = YesNo(IniRead($Ini,"NewsReader","Repeat",1))
	HrParse(IniRead($ini,"NewsReader","Silent","23-7"),$time) 
	If $time[1] <= @HOUR And $time[2] > @HOUR Then
		Run("AT " & $time[2] & ':00 "' & @ScriptDir & '\Headlines_Reader.exe"',@ScriptDir,@SW_HIDE )
		Exit
	EndIf
	If $repeat==1 Then 
		$Time = @HOUR + 1 & ":00"
		Run("AT " & $Time & ' "' & @ScriptDir & '\Headlines_Reader.exe"',@ScriptDir,@SW_HIDE )
	EndIf
	For $_i = 1 To $_Type[0]
		$_Type[$_i] = StringStripWS($_Type[$_i], 3)
	Next
	Return
EndFunc   ;==>GetParms

Func HrParse($parm, ByRef $_Array)
	If $parm="" then return $parm="0-0"
	If StringInStr($parm,"immediate") then $parm="0-0"
	$parm=StringStripWS($parm,3)
	$parm=StringReplace($parm,"noon","12")
	$parm=StringReplace($parm,"midnight","0")
	$parm=StringReplace($parm,"-","|",1)
	$parm=StringReplace($parm,"thru","|",1)
	$parm=StringReplace($parm,"am","")
	$_Array = StringSplit($parm,"|",1)
	If $_Array[0]>0  And StringInStr($_Array[1],"pm") Then $_Array[1]=Number($_Array[1])+12
	If $_Array[0]>1 And StringInStr($_Array[2],"pm") Then $_Array[2]=Number($_Array[2])+12
EndFunc   ;==>HrParse
	
	
Func CheckInstall()
	$InstallDir = RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader","InstallDir")
	If @error = 1  Then 
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader")
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader","InstallDir","REG_SZ",@ScriptDir)
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader","Version","REG_SZ","1.0.0.0")
	If Not FileExists(@StartupDir  & "\Headlines_Reader.lnk") Then 
		FileCreateShortcut(@ScriptDir & "\Headlines_Reader",@StartupDir & "\Headlines_Reader.lnk")
		TrayTip("Install",@StartupDir & "\Headlines_Reader.lnk created!",2)
		Sleep(1000)
	EndIf
	EndIf
	If $InstallDir <> @ScriptDir Then 
		RegWrite("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader","InstallDir","REG_SZ",@ScriptDir)
		TrayTip("Install", "\Headlines_Reader InstallDir registered!",2)
		Sleep(1000)
	EndIf
EndFunc
	
Func Uninstall()
	TrayTip("UnInstall","Uninstalling.....!",2)
	Sleep(2000)
	RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader","Version")
	RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader","Installdir")
	RegDelete("HKEY_LOCAL_MACHINE\SOFTWARE\Headlines_Reader")
	If FileExists(@StartupDir & "\Headlines_Reader.lnk") Then 
		FileDelete(@StartupDir & "\Headlines_Reader.lnk")
	EndIf
	Run("AT /DELETE /YES",@ScriptDir,@SW_HIDE )
	_IEQuit($oIE)
	Exit
EndFunc

Func YesNo($parm)
	$parm = StringStripWS($parm, 3)
	If StringIsAlpha($parm) Then
		If StringInStr($parm, "yes") Then
			Return 1
		Else
			Return 0
		EndIf
	Else
		Return Number($parm)
	EndIf
	Return 0
EndFunc   ;==>YesNo

Func Gender($parm)
	$parm = StringStripWS($parm, 3)
	Select
		Case $parm = "Female"
			Return 1
		Case $parm = "Male"
			Return 2
		Case $parm = "OldMan"
			Return 3
		Case Else
			Return 0
	EndSelect
EndFunc   ;==>Gender

Func _IEGetHeadlines($o_collection, ByRef $HL)
	Dim $adata[5]
    Dim $i = 0
	Dim $Index = 0
	For $a In $o_collection
        SetError(0)
        $tmp = $a.id
        If @error = 1 Then $tmp = ""
        If $tmp = "0" Then $tmp = ""
		If $a.tagname = "a" And StringLen($tmp)>5 Then
			$Index = $Index + 1
			$HL[$Index] = $a.innerText
		EndIf
	Next
	If $Index>0 Then $HL[0] = $Index + 1
EndFunc
	